function logprob = log_prediction(pair_xi, query_mu, query_sigma_inv, ...
    pair_mu, pair_sigma_inv)

logistic_zeta = 1/(1 + exp(-pair_xi));
pair_lambda_xi = tanh(pair_xi/2)/(4 * pair_xi);

%eq is from Silva's paper
logprob = log(logistic_zeta) - 0.5 * pair_xi + ...
    pair_lambda_xi * pair_xi^2 - 0.5 * query_mu' * ...
    query_sigma_inv * query_mu + 0.5 * pair_mu' * ...
    pair_sigma_inv * pair_mu + 0.5 * ...
    (log(det(query_sigma_inv) / det(pair_sigma_inv)));


% % eq is from the paper by Jaakkola & Jordan, 1999
% logprob = log(logistic_zeta) - 0.5 * pair_xi + ...
%     pair_lambda_xi * pair_xi^2 - 0.5 * query_mu' * ...
%     query_sigma_inv * query_mu + 0.5 * pair_mu' * ...
%     pair_sigma_inv * pair_mu + 0.5 * ...
%     (log(det(inv(pair_sigma_inv)) / det(inv(query_sigma_inv))));